Description: ACPI: acpi_table_parse() should return handler's error code
 Currently, the error code returned by acpi_table_parse()'s handler
 is ignored. This patch will propagate handler's return value to
 acpi_table_parse()'s caller.
From: Boris Ostrovsky <boris.ostrovsky@amd.com>
Origin: upstream, commit:23448:dd6694df1a31
Id: CVE-2013-0153
---
--- a/xen/drivers/acpi/tables.c	Thu Jan 17 16:11:02 2013 +0000
+++ b/xen/drivers/acpi/tables.c	Tue Feb 05 15:34:55 2013 +0100
@@ -267,7 +267,7 @@
  * @handler: handler to run
  *
  * Scan the ACPI System Descriptor Table (STD) for a table matching @id,
- * run @handler on it.  Return 0 if table found, return on if not.
+ * run @handler on it.
  */
 int acpi_table_parse(char *id, acpi_table_handler handler)
 {
@@ -282,8 +282,7 @@
 		acpi_get_table(id, 0, &table);
 
 	if (table) {
-		handler(table);
-		return 0;
+		return handler(table);
 	} else
 		return 1;
 }
